summaryrefslogtreecommitdiff
path: root/make-macosx.sh
diff options
context:
space:
mode:
Diffstat (limited to 'make-macosx.sh')
-rwxr-xr-xmake-macosx.sh62
1 files changed, 32 insertions, 30 deletions
diff --git a/make-macosx.sh b/make-macosx.sh
index 2a09ea1f..ebc56c90 100755
--- a/make-macosx.sh
+++ b/make-macosx.sh
@@ -1,35 +1,39 @@
#!/bin/sh
+#
+# BUILDARCH can be set to either i386, x86_64 or ppc
+BUILDARCH=x86_64
+
CC=gcc-4.0
APPBUNDLE=ioquake3.app
-BINARY=ioquake3.x86_64
-DEDBIN=ioq3ded.x86_64
+BINARY=ioquake3.${BUILDARCH}
+DEDBIN=ioq3ded.${BUILDARCH}
PKGINFO=APPLIOQ3
ICNS=misc/quake3.icns
-DESTDIR=build/release-darwin-x86_64
+DESTDIR=build/release-darwin-${BUILDARCH}
BASEDIR=baseq3
MPACKDIR=missionpack
BIN_OBJ="
- build/release-darwin-x86_64/ioquake3.x86_64
+ build/release-darwin-${BUILDARCH}/ioquake3.${BUILDARCH}
"
BIN_DEDOBJ="
- build/release-darwin-x86_64/ioq3ded.x86_64
+ build/release-darwin-${BUILDARCH}/ioq3ded.${BUILDARCH}
"
BASE_OBJ="
- build/release-darwin-x86_64/$BASEDIR/cgamex86_64.dylib
- build/release-darwin-x86_64/$BASEDIR/uix86_64.dylib
- build/release-darwin-x86_64/$BASEDIR/qagamex86_64.dylib
+ build/release-darwin-${BUILDARCH}/$BASEDIR/cgame${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/$BASEDIR/ui${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/$BASEDIR/qagame${BUILDARCH}.dylib
"
MPACK_OBJ="
- build/release-darwin-x86_64/$MPACKDIR/cgamex86_64.dylib
- build/release-darwin-x86_64/$MPACKDIR/uix86_64.dylib
- build/release-darwin-x86_64/$MPACKDIR/qagamex86_64.dylib
+ build/release-darwin-${BUILDARCH}/$MPACKDIR/cgame${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/$MPACKDIR/ui${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/$MPACKDIR/qagame${BUILDARCH}.dylib
"
RENDER_OBJ="
- build/release-darwin-x86_64/renderer_opengl1_smp_x86_64.dylib
- build/release-darwin-x86_64/renderer_opengl1_x86_64.dylib
- build/release-darwin-x86_64/renderer_rend2_smp_x86_64.dylib
- build/release-darwin-x86_64/renderer_rend2_x86_64.dylib
+ build/release-darwin-${BUILDARCH}/renderer_opengl1_smp_${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/renderer_opengl1_${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/renderer_rend2_smp_${BUILDARCH}.dylib
+ build/release-darwin-${BUILDARCH}/renderer_rend2_${BUILDARCH}.dylib
"
cd `dirname $0`
@@ -48,19 +52,21 @@ TIGERHOST=`uname -r |perl -w -p -e 's/\A(\d+)\..*\Z/$1/; $_ = (($_ >= 8) ? "1" :
# can not build 64bit binaries, making 10.5 the minimum version. This has been tested
# with xcode 3.1 (xcode31_2199_developerdvd.dmg). It contains the 10.5 SDK and a decent
# enough gcc to actually compile ioquake3
+# For PPC macs, G4's or better are required to run ioquake3.
+
+unset ARCH_SDK
+unset ARCH_CFLAGS
+unset ARCH_LDFLAGS
-unset X86_SDK
-unset X86_CFLAGS
-unset X86_LDFLAGS
if [ -d /Developer/SDKs/MacOSX10.5.sdk ]; then
- X86_SDK=/Developer/SDKs/MacOSX10.5.sdk
- X86_CFLAGS="-arch x86_64 -isysroot /Developer/SDKs/MacOSX10.5.sdk \
+ ARCH_SDK=/Developer/SDKs/MacOSX10.5.sdk
+ ARCH_CFLAGS="-arch ${BUILDARCH} -isysroot /Developer/SDKs/MacOSX10.5.sdk \
-DMAC_OS_X_VERSION_MIN_REQUIRED=1050"
- X86_LDFLAGS=" -mmacosx-version-min=10.5"
+ ARCH_LDFLAGS=" -mmacosx-version-min=10.5"
fi
-echo "Building X86 Client/Dedicated Server against \"$X86_SDK\""
+echo "Building ${BUILDARCH} Client/Dedicated Server against \"$ARCH_SDK\""
sleep 3
if [ ! -d $DESTDIR ]; then
@@ -72,10 +78,10 @@ NCPU=`sysctl -n hw.ncpu`
# intel client and server
-if [ -d build/release-darwin-x86_64 ]; then
- rm -r build/release-darwin-x86_64
+if [ -d build/release-darwin-${BUILDARCH} ]; then
+ rm -r build/release-darwin-${BUILDARCH}
fi
-(ARCH=x86_64 CFLAGS=$X86_CFLAGS LDFLAGS=$X86_LDFLAGS make -j$NCPU) || exit 1;
+(ARCH=${BUILDARCH} CFLAGS=$ARCH_CFLAGS LDFLAGS=$ARCH_LDFLAGS make -j$NCPU) || exit 1;
echo "Creating .app bundle $DESTDIR/$APPBUNDLE"
if [ ! -d $DESTDIR/$APPBUNDLE/Contents/MacOS/$BASEDIR ]; then
@@ -126,11 +132,6 @@ echo "
</plist>
" > $DESTDIR/$APPBUNDLE/Contents/Info.plist
-for i in $BIN_OBJ $BIN_DEDOBJ $RENDER_OBJ
-do
- install_name_tool -change "@rpath/SDL.framework/Versions/A/SDL" "@executable_path/../Frameworks/SDL.framework/Versions/A/SDL" $i
-done
-
cp $BIN_OBJ $DESTDIR/$APPBUNDLE/Contents/MacOS/$BINARY
cp $BIN_DEDOBJ $DESTDIR/$APPBUNDLE/Contents/MacOS/$DEDBIN
@@ -138,4 +139,5 @@ cp $RENDER_OBJ $DESTDIR/$APPBUNDLE/Contents/MacOS/
cp $BASE_OBJ $DESTDIR/$APPBUNDLE/Contents/MacOS/$BASEDIR/
cp $MPACK_OBJ $DESTDIR/$APPBUNDLE/Contents/MacOS/$MPACKDIR/
cp code/libs/macosx/*.dylib $DESTDIR/$APPBUNDLE/Contents/MacOS/
+cp code/libs/macosx/*.dylib $DESTDIR